/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> 

	Da usare per il Challenge del Corso A (2009)

   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */


#include <stdlib.h>
#include <stdio.h>


// ----- Procedura ausiliaria: 
//
// Legge un file di nome <fileName> e lo carica in una stringa 
// (*Testo) di lunghezza (*LenTesto).
// I parametri sono passati per "riferimento" in quanto vengono
// creati all'interno di questa procedura.
//
void LeggiFile(char *fileName, int *LenTesto, char **Testo)
{
  FILE *Infile;
  int err;

  // Sanity check
  if (fileName == NULL){
    fprintf(stderr, "Nome File vuoto!\n");
    exit(1); 
  }

  // Apre il file in lettura
  Infile=fopen(fileName, "r"); 
  if(Infile == NULL) {
    fprintf(stderr, "Errore nell'aprire %s\n",fileName);
    exit(1);  }

  // Calcola la lunghezza del file
  fseek(Infile,0,SEEK_END);
  *LenTesto=ftell(Infile);
  if (*LenTesto <= 0) {
    fprintf(stderr, "Errore nel calcolare la lunghezza dell'input\n"); 
    exit(1);  } 


  // Alloca e carica da file la stringa testo 
  *Testo = (char *) malloc((*LenTesto) + 1); 
  rewind(Infile); 
  err=fread(*Testo, (size_t) 1, (size_t) (*LenTesto), Infile);
  if(err != *LenTesto){ 
    fprintf(stderr, "Errore nella lettura del file di input!");
    exit(1);  }

  // Aggiunge il terminatore di stringa
  (*Testo)[*LenTesto] = '\0';

  // chiude il file di input
  fclose(Infile);
}


// ----- Procedura ausiliaria: vista in classe
//
// Confronta due stringhe e restituisce -1, 0, 1 se s1 <, =, > s2
int confrStringhe( const void *s1, const void *s2 ) 
{
   
   
  /* I due parametri sono dei puntatori ai valori dell'array che
   * andremo ad ordinare, ovvero 2 puntatori a puntatori di stringhe:
   * char **. Prima li "interpretiamo" con un cast a puntatori a
   * stringhe, poi li dereferenziamo per ottenere l'effettiva
   * stringa. */
  char *stringa1 = *(char **)s1;
  char *stringa2 = *(char **)s2;
  int i;

  // Confronto alfabetico tra due stringhe. 
  i = 0;
  while ( stringa1[i] != '\0' && stringa1[i] == stringa2[i] ) 
    i++;

  if ( stringa1[i] < stringa2[i] ) 
    return -1;
  else if ( stringa1[i] == stringa2[i] ) 
    return 0;
  else
    return 1;
}


// ----- Procedura ausiliaria: nuova!
//
// Calcola il piu' lungo prefisso comune tra due suffissi (denominato
// lcp).  Questi sono terminati da NULL e, trattandosi di suffissi 
// di una stessa stringa, hanno lunghezze diverse e quindi si 
// differenziano in almeno un carattere.
int lcp( const void *s1, const void *s2 ) 
{
  int len;
  char *s = (char *)s1;
  char *t = (char *)s2;

  for(len = 0; s[len] == t[len]; len++){ }

  return len;
}


// ------------------------------------------------------------
// ----- MAIN
// ------------------------------------------------------------
int main(int argc, char *argv[])
{  
  char *infile_name = "testo.txt"; // potete cambiarlo se volete !!
  char *Text;   // variabile che conterra' il testo
  int TextLen;  // variabile che conterra' la lunghezza del testo
  char **SA; // Array di suffissi al testo Text
  int i;
  int maxlcp; // variabile che conterra' la maxlen ripetuta
  int lcptmp; // variabile ausiliaria per calcolare il maxlcp
  int pos; // posizione in SA del suffisso a cui si riferisce maxlcp



  // Legge da file il testo e lo memorizza in Text
  // La lunghezza di Text viene memorizzata in TextLen
  LeggiFile("testo.txt", &TextLen, &Text);
  printf("\n\nHo letto %d bytes di -testo.txt-\n",TextLen);
  
  // Crea e inizializza l'array di suffissi con puntatori
  // alle stringhe che sono tutti i suffissi del testo Text
  SA = (char **) malloc(sizeof(char *) * TextLen);
  if (SA == NULL){
    printf("Errore nell'allocazione di SA!\n");
    return -1;  }
  for(i=0; i < TextLen; i++)
    SA[i] = Text+i;

  // ordina i suffissi del testo
  qsort( SA, TextLen, sizeof(char *), confrStringhe);

  // calcola la piu' lunga sottostringa ripetuta
  maxlcp = -1; pos = -1;
  for ( i = 1; i < TextLen; i++ ) {
    lcptmp = lcp(SA[i], SA[i-1]);
    if ( lcptmp > maxlcp){
      maxlcp = lcptmp;
      pos = i;  }
  }

  // Stampa il risultato
  printf("\n\n----- Trovata una ripetizione di %d chars\n\n", maxlcp);
  for (i=0; i < maxlcp; i++)
    printf("%c",*(SA[pos]+i));
  printf("\n\n");
   
  return 0;
}

